
#include <Servo.h> 
#include <digitalWriteFast.h>

#define TURN90_DELAY 300
#define TURN_SPEED 80
#define FWD_SPEED 100
#define BWD_SPEED -80

#define R_CENTER 90
#define L_CENTER 90

#define MAX_SPEED 255

#define LEFT_BUMP_PIN 3
#define RIGHT_BUMP_PIN A4
#define LEFT_SERVO 9
#define RIGHT_SERVO 8


float center_shift_L = 8;    
float center_shift_R = 0; 

Servo servoL, servoR;


void setup() {
   pinMode( RIGHT_BUMP_PIN, INPUT_PULLUP);
   pinMode( LEFT_BUMP_PIN,  INPUT_PULLUP);
  servoR.attach(RIGHT_SERVO); 
  servoL.attach(LEFT_SERVO); 
}


void loop()
{

   int leftBump   = !digitalRead( LEFT_BUMP_PIN  );
   int rightBump  = !digitalRead( RIGHT_BUMP_PIN );
      if (leftBump && rightBump) {
            AllStop(); 
            AllBackward(BWD_SPEED);
            delay(1000);
            turnRight180();   
      }
      else if(leftBump) {
            AllStop(); 
            AllBackward(BWD_SPEED);
            delay(1000); 
            turnRight90();
      }
      else if (rightBump) {
            AllStop(); 
            AllBackward(BWD_SPEED);
            delay(1000); 
            turnLeft90();
      }
      else {
            AllForward(FWD_SPEED); 
            delay(110); 
      }
}






void AllStop() {
    setSpeed_LR(0, 0);
}
void AllForward(int fwd_speed) { 
    setSpeed_LR(fwd_speed, fwd_speed);
}
void turnLeft90() { 
    setSpeed_LR(-TURN_SPEED, TURN_SPEED);
    delay(TURN90_DELAY); 
}
void turnRight90() { 
    setSpeed_LR(TURN_SPEED, -TURN_SPEED);
    delay(TURN90_DELAY); 
}
void turnRight180() { 
    setSpeed_LR(TURN_SPEED, -TURN_SPEED);
    delay(2*TURN90_DELAY); 
}
void AllBackward(int bwd_speed) { 
    setSpeed_LR(bwd_speed, bwd_speed);
}

//---------------------------------------------------
void setSpeed_LR(int speedL, int speedR)
{
   servoL.write(map(speedL, -MAX_SPEED,MAX_SPEED,0+center_shift_L,180+center_shift_L));
   servoR.write(map(speedR, -MAX_SPEED,MAX_SPEED,180+center_shift_R,0+center_shift_R));
}
